<!--
 Copyright (c) 2000-2025 Ericsson Telecom AB
 All rights reserved. This program and the accompanying materials
 are made available under the terms of the Eclipse Public License v2.0
 which accompanies this distribution, and is available at
 https://www.eclipse.org/org/documents/epl-2.0/EPL-2.0.html

 Contributors:
  Balasko, Jeno
  Raduly, Csaba
-->
<xs:schema xmlns:xs='http://www.w3.org/2001/XMLSchema'>
 <xs:element name='address'>
  <xs:complexType>
  <xs:attribute name='address-value' use='required'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='badmessage-response'>
  <xs:complexType>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  <xs:attribute name='bad-message-fragment'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='cancel-message'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address' minOccurs='0' maxOccurs='unbounded'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='cancel-response'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='cancel-result' maxOccurs='unbounded'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='cancel-result'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address' minOccurs='0' maxOccurs='unbounded'/>
   </xs:sequence>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='ccq-message'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address'/>
   </xs:sequence>
  <xs:attribute name='query-id'/>
  <xs:attribute name='app-id'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='ccq-response'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address'/>
   </xs:sequence>
  <xs:attribute name='query-id'/>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='pap'>
  <xs:complexType>
   <xs:choice>
     <xs:element ref='push-message'/>
     <xs:element ref='push-response'/>
     <xs:element ref='cancel-message'/>
     <xs:element ref='cancel-response'/>
     <xs:element ref='resultnotification-message'/>
     <xs:element ref='resultnotification-response'/>
     <xs:element ref='statusquery-message'/>
     <xs:element ref='statusquery-response'/>
     <xs:element ref='ccq-message'/>
     <xs:element ref='ccq-response'/>
     <xs:element ref='badmessage-response'/>
   </xs:choice>
  <xs:attribute name='product-name'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='progress-note'>
  <xs:complexType>
  <xs:attribute name='stage' use='required'/>
  <xs:attribute name='note'/>
  <xs:attribute name='time'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='push-message'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address' maxOccurs='unbounded'/>
     <xs:element ref='quality-of-service' minOccurs='0'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  <xs:attribute name='replace-push-id'/>
  <xs:attribute name='replace-method' default='all'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='pending-only'/>
     <xs:enumeration value='all'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='deliver-before-timestamp'/>
  <xs:attribute name='deliver-after-timestamp'/>
  <xs:attribute name='source-reference'/>
  <xs:attribute name='ppg-notify-requested-to'/>
  <xs:attribute name='progress-notes-requested' default='false'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='true'/>
     <xs:enumeration value='false'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  </xs:complexType>
 </xs:element>
 <xs:element name='push-response'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='progress-note' minOccurs='0' maxOccurs='unbounded'/>
     <xs:element ref='response-result'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  <xs:attribute name='sender-address'/>
  <xs:attribute name='sender-name'/>
  <xs:attribute name='reply-time'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='quality-of-service'>
  <xs:complexType>
  <xs:attribute name='priority' default='medium'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='high'/>
     <xs:enumeration value='medium'/>
     <xs:enumeration value='low'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='delivery-method' default='notspecified'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='confirmed'/>
     <xs:enumeration value='preferconfirmed'/>
     <xs:enumeration value='unconfirmed'/>
     <xs:enumeration value='notspecified'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='network'/>
  <xs:attribute name='network-required' default='false'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='true'/>
     <xs:enumeration value='false'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='bearer'/>
  <xs:attribute name='bearer-required' default='false'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='true'/>
     <xs:enumeration value='false'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  </xs:complexType>
 </xs:element>
 <xs:element name='response-result'>
  <xs:complexType>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='resultnotification-message'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address'/>
     <xs:element ref='quality-of-service' minOccurs='0'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  <xs:attribute name='sender-address'/>
  <xs:attribute name='sender-name'/>
  <xs:attribute name='received-time'/>
  <xs:attribute name='event-time'/>
  <xs:attribute name='message-state' use='required'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='rejected'/>
     <xs:enumeration value='pending'/>
     <xs:enumeration value='delivered'/>
     <xs:enumeration value='undeliverable'/>
     <xs:enumeration value='expired'/>
     <xs:enumeration value='aborted'/>
     <xs:enumeration value='timeout'/>
     <xs:enumeration value='cancelled'/>
     <xs:enumeration value='unknown'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='resultnotification-response'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='statusquery-message'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address' minOccurs='0' maxOccurs='unbounded'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='statusquery-response'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='statusquery-result' maxOccurs='unbounded'/>
   </xs:sequence>
  <xs:attribute name='push-id' use='required'/>
  </xs:complexType>
 </xs:element>
 <xs:element name='statusquery-result'>
  <xs:complexType>
   <xs:sequence>
     <xs:element ref='address' minOccurs='0' maxOccurs='unbounded'/>
     <xs:element ref='quality-of-service' minOccurs='0'/>
   </xs:sequence>
  <xs:attribute name='event-time'/>
  <xs:attribute name='message-state' use='required'>
   <xs:simpleType>
    <xs:restriction base='xs:string'>
     <xs:enumeration value='rejected'/>
     <xs:enumeration value='pending'/>
     <xs:enumeration value='delivered'/>
     <xs:enumeration value='undeliverable'/>
     <xs:enumeration value='expired'/>
     <xs:enumeration value='aborted'/>
     <xs:enumeration value='timeout'/>
     <xs:enumeration value='cancelled'/>
     <xs:enumeration value='unknown'/>
    </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name='code' use='required'/>
  <xs:attribute name='desc'/>
  </xs:complexType>
 </xs:element>
</xs:schema>
